Option Explicit
Dim s ' As ADODB.Stream

DoIt  ' run the Sub


Sub DoIt
Dim objArgs, strInFileSpec, recordType, recordLength, counts(3), strOut

Set objArgs = WScript.Arguments
If objArgs.Count = 0 Then
	WScript.Echo "This script expects a filename as an argument or an .ov2 file dropped onto it (GUI mode)."
	Exit Sub
Else
	strInFileSpec = objArgs(0)
End If

Set s = CreateObject("ADODB.Stream")
s.Type = 2  ' adTypeText
s.Charset = "iso-8859-1"
s.Open
s.LoadFromFile strInFileSpec

counts(0) = 0
counts(1) = 0
counts(2) = 0
counts(3) = 0

Do Until s.EOS
	recordType = GetIntegerFromStream(1)
	Select Case recordType
		Case 0, 2, 3
			recordLength = GetIntegerFromStream(4)
			s.ReadText(recordLength - 5)
		Case 1
			recordLength = 21
			s.ReadText(recordLength - 1)
		Case Else
			WScript.Echo "Unrecognized record type encountered (" & recordType & "). Quitting."
			Exit Sub
	End Select
	counts(recordType) = counts(recordType) + 1
Loop
s.Close
strOut = ""
strOut = strOut & "deleted POI records (type 0):" & VBTab & counts(0) & VBCrLf
strOut = strOut & """skipper"" records (type 1):" & VBTab & counts(1) & VBCrLf
strOut = strOut & "regular POI records (type 2):" & VBTab & counts(2) & VBCrLf
strOut = strOut & "extended POI records (type 3):" & VBTab & counts(3) & VBCrLf
Wscript.Echo strOut
End Sub

Function GetIntegerFromStream(numBytes)
Dim result, b, i
b = s.ReadText(numBytes)
result = 0
For i = numBytes To 1 Step -1
  result = (result * 256) + Asc(Mid(b,i,1))
Next
GetIntegerFromStream = result
End Function
